From dec7943639f770edab6e391d88d2871f1d15c774 Mon Sep 17 00:00:00 2001
From: Radim Hopp <rhopp@redhat.com>
Date: Thu, 24 Oct 2019 11:14:25 +0200
Subject: [PATCH] Append ?sanitize=true to svg URLs.

This should fix https://issues.jboss.org/browse/CRW-427

Signed-off-by: Radim Hopp <rhopp@redhat.com>
---
 devfiles/cakephp-ex/meta.yaml               | 2 +-
 devfiles/cpp/meta.yaml                      | 2 +-
 devfiles/dotnet/meta.yaml                   | 2 +-
 devfiles/go/meta.yaml                       | 2 +-
 devfiles/java-eap-maven/meta.yaml           | 2 +-
 devfiles/java-eap-thorntail/meta.yaml       | 2 +-
 devfiles/java-jboss-fuse/meta.yaml          | 2 +-
 devfiles/java-maven/meta.yaml               | 2 +-
 devfiles/nodejs-mongo/meta.yaml             | 2 +-
 devfiles/php-web-simple/meta.yaml           | 2 +-
 devfiles/python/meta.yaml                   | 2 +-
 devfiles/spring-boot-http-booster/meta.yaml | 2 +-
 devfiles/vertx-http-booster/meta.yaml       | 2 +-
 devfiles/web-nodejs-simple/meta.yaml        | 2 +-
 14 files changed, 14 insertions(+), 14 deletions(-)

diff --git a/devfiles/cakephp-ex/meta.yaml b/devfiles/cakephp-ex/meta.yaml
index 909313f..4af66e3 100644
--- a/devfiles/cakephp-ex/meta.yaml
+++ b/devfiles/cakephp-ex/meta.yaml
@@ -2,5 +2,5 @@
 displayName: "CakePHP Example"
 description: PHP Stack with PHP 7.1 and a quickstart CakePHP application for OpenShift v3
 tags: ["PHP", "Apache", "RHEL"]
-icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-php.svg
+icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-php.svg?sanitize=true
 globalMemoryLimit: 2430Mi
diff --git a/devfiles/cpp/meta.yaml b/devfiles/cpp/meta.yaml
index a954392..94c57c2 100644
--- a/devfiles/cpp/meta.yaml
+++ b/devfiles/cpp/meta.yaml
@@ -2,5 +2,5 @@
 displayName: C/C++
 description: C and C++ Developer Tools stack
 tags: ["c", "c++", "clang", "g++", "make", "cmake"]
-icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-cpp.svg
+icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-cpp.svg?sanitize=true
 globalMemoryLimit: 1686Mi
diff --git a/devfiles/dotnet/meta.yaml b/devfiles/dotnet/meta.yaml
index 8af550b..bbd4c12 100644
--- a/devfiles/dotnet/meta.yaml
+++ b/devfiles/dotnet/meta.yaml
@@ -2,5 +2,5 @@
 displayName: ".NET"
 description: .NET 2.1 stack with .NET Core SDK and Runtime
 tags: [".NET", "C#"]
-icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-dotnet.svg
+icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-dotnet.svg?sanitize=true
 globalMemoryLimit: 2198Mi
diff --git a/devfiles/go/meta.yaml b/devfiles/go/meta.yaml
index 3fd4bdf..f792f65 100644
--- a/devfiles/go/meta.yaml
+++ b/devfiles/go/meta.yaml
@@ -2,5 +2,5 @@
 displayName: Go
 description: Stack with Go 1.11.5
 tags: ["Go"]
-icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-go.svg
+icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-go.svg?sanitize=true
 globalMemoryLimit: 1686Mi
diff --git a/devfiles/java-eap-maven/meta.yaml b/devfiles/java-eap-maven/meta.yaml
index 5d3c1e6..b158882 100644
--- a/devfiles/java-eap-maven/meta.yaml
+++ b/devfiles/java-eap-maven/meta.yaml
@@ -2,5 +2,5 @@
 displayName: Java EAP Maven
 description: RHEL 8 Java stack with EAP 7.2, OpenJDK 1.8 and Maven 3.5
 tags: ["Java", "OpenJDK", "Maven", "EAP"]
-icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-jboss.svg
+icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-jboss.svg?sanitize=true
 globalMemoryLimit: 2674Mi
diff --git a/devfiles/java-eap-thorntail/meta.yaml b/devfiles/java-eap-thorntail/meta.yaml
index 927f192..d235bf8 100644
--- a/devfiles/java-eap-thorntail/meta.yaml
+++ b/devfiles/java-eap-thorntail/meta.yaml
@@ -2,5 +2,5 @@
 displayName: Thorntail REST HTTP
 description: Quickstart to expose a REST Greeting endpoint using Thorntail
 tags: ["Java", "OpenJDK", "Maven", "EAP"]
-icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-jboss.svg
+icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-jboss.svg?sanitize=true
 globalMemoryLimit: 2674Mi
diff --git a/devfiles/java-jboss-fuse/meta.yaml b/devfiles/java-jboss-fuse/meta.yaml
index c944176..a83eb2f 100644
--- a/devfiles/java-jboss-fuse/meta.yaml
+++ b/devfiles/java-jboss-fuse/meta.yaml
@@ -2,5 +2,5 @@
 displayName: Red Hat Fuse
 description: Red Hat Fuse
 tags: ["OpenJDK", "Maven", "EAP"]
-icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-fuse.svg
+icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-fuse.svg?sanitize=true
 globalMemoryLimit: 2816Mi
diff --git a/devfiles/java-maven/meta.yaml b/devfiles/java-maven/meta.yaml
index 7c57274..57958c2 100644
--- a/devfiles/java-maven/meta.yaml
+++ b/devfiles/java-maven/meta.yaml
@@ -2,5 +2,5 @@
 displayName: Java Maven
 description: Java Stack with OpenJDK 8 and Maven 3.5.4
 tags: ["Java", "OpenJDK", "Maven"]
-icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-java.svg
+icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-java.svg?sanitize=true
 globalMemoryLimit: 2674Mi
diff --git a/devfiles/nodejs-mongo/meta.yaml b/devfiles/nodejs-mongo/meta.yaml
index 543e87f..299ac3c 100644
--- a/devfiles/nodejs-mongo/meta.yaml
+++ b/devfiles/nodejs-mongo/meta.yaml
@@ -2,5 +2,5 @@
 displayName: NodeJS MongoDB Web Application
 description: Stack with NodeJS 10 and MongoDB 3.4
 tags: ["NodeJS", "Express", "MongoDB", "RealWorld", "ubi8", "Centos"]
-icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-node.svg
+icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-node.svg?sanitize=true
 globalMemoryLimit: 1686Mi
diff --git a/devfiles/php-web-simple/meta.yaml b/devfiles/php-web-simple/meta.yaml
index 921d18e..439a20b 100644
--- a/devfiles/php-web-simple/meta.yaml
+++ b/devfiles/php-web-simple/meta.yaml
@@ -2,5 +2,5 @@
 displayName: "PHP Simple"
 description: PHP Stack with PHP 7.1 and simple web application
 tags: ["PHP", "Apache", "RHEL"]
-icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-php.svg
+icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-php.svg?sanitize=true
 globalMemoryLimit: 2430Mi
diff --git a/devfiles/python/meta.yaml b/devfiles/python/meta.yaml
index 96c030b..4dd0b9f 100644
--- a/devfiles/python/meta.yaml
+++ b/devfiles/python/meta.yaml
@@ -2,5 +2,5 @@
 displayName: Python
 description: Python Stack with Python 3.6
 tags: ["Python", "pip"]
-icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-python.svg
+icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-python.svg?sanitize=true
 globalMemoryLimit: 1686Mi
diff --git a/devfiles/spring-boot-http-booster/meta.yaml b/devfiles/spring-boot-http-booster/meta.yaml
index fb13fb7..b131dd9 100644
--- a/devfiles/spring-boot-http-booster/meta.yaml
+++ b/devfiles/spring-boot-http-booster/meta.yaml
@@ -2,5 +2,5 @@
 displayName: Java Spring Boot
 description: Java stack with OpenJDK 8 and Spring Boot Petclinic demo application
 tags: ["Java", "OpenJDK", "Maven", "Spring Boot"]
-icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-sprint-boot.svg
+icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-sprint-boot.svg?sanitize=true
 globalMemoryLimit: 3072Mi
diff --git a/devfiles/vertx-http-booster/meta.yaml b/devfiles/vertx-http-booster/meta.yaml
index df06666..bd17094 100644
--- a/devfiles/vertx-http-booster/meta.yaml
+++ b/devfiles/vertx-http-booster/meta.yaml
@@ -2,5 +2,5 @@
 displayName: Java Vert.x
 description: Java stack with OpenJDK 8 and Vert.x demo application
 tags: ["Java", "OpenJDK", "Maven", "Vertx"]
-icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-spring-boot.svg
+icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-spring-boot.svg?sanitize=true
 globalMemoryLimit: 2674Mi
diff --git a/devfiles/web-nodejs-simple/meta.yaml b/devfiles/web-nodejs-simple/meta.yaml
index c86cb1e..a45916d 100644
--- a/devfiles/web-nodejs-simple/meta.yaml
+++ b/devfiles/web-nodejs-simple/meta.yaml
@@ -2,5 +2,5 @@
 displayName: NodeJS Express Web Application
 description: Stack with NodeJS 10
 tags: ["NodeJS", "Express", "ubi8"]
-icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-node.svg
+icon: https://raw.githubusercontent.com/redhat-developer/codeready-workspaces/master/ide/codeready-ide-stacks/src/main/resources/stacks-images/type-node.svg?sanitize=true
 globalMemoryLimit: 1686Mi
-- 
2.21.0