diff --git a/testsuite/integration/basic/src/test/java/acme_proxy/DynamicServlet.java b/testsuite/integration/basic/src/test/java/acme_proxy/DynamicServlet.java
new file mode 100644
index 0000000000..ba4c769443
--- /dev/null
+++ b/testsuite/integration/basic/src/test/java/acme_proxy/DynamicServlet.java
@@ -0,0 +1,30 @@
+package acme_proxy;
+
+import java.io.IOException;
+
+import javax.annotation.Resource;
+import javax.enterprise.concurrent.ManagedExecutorService;
+import javax.inject.Inject;
+import javax.servlet.ServletException;
+import javax.servlet.http.HttpServlet;
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
+
+public class DynamicServlet extends HttpServlet {
+    private static final long serialVersionUID = 1L;
+
+    @Resource
+    private ManagedExecutorService executor;
+    @Resource(lookup = "java:comp/env/ResourceFromWebXml")
+    private Object resourceByLookupName;
+    @Inject
+    private InjectMePlease managedBean;
+    @Override
+    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
+        resp.setContentType("text/plain");
+        //resp.getWriter().println(this.managedBean != null ? "Yay!" : "Oh no!");
+        //resp.getWriter().println(this.executor != null ? "Yay!" : "Oh no!");
+        //resp.getWriter().println(this.resourceByLookupName != null ? "Yay!" : "Oh no!");
+        resp.getWriter().println(this.executor + " "+ this.managedBean+ " " + this.resourceByLookupName);
+    }
+}
\ No newline at end of file
diff --git a/testsuite/integration/basic/src/test/java/acme_proxy/Initialiser.java b/testsuite/integration/basic/src/test/java/acme_proxy/Initialiser.java
new file mode 100644
index 0000000000..d7a054be3b
--- /dev/null
+++ b/testsuite/integration/basic/src/test/java/acme_proxy/Initialiser.java
@@ -0,0 +1,14 @@
+package acme_proxy;
+
+import java.util.Set;
+
+import javax.servlet.ServletContainerInitializer;
+import javax.servlet.ServletContext;
+import javax.servlet.ServletException;
+
+public class Initialiser implements ServletContainerInitializer {
+    @Override
+    public void onStartup(Set<Class<?>> c, ServletContext ctx) throws ServletException {
+        ctx.addServlet("acme", DynamicServlet.class).addMapping("/dynamic");
+    }
+}
\ No newline at end of file
diff --git a/testsuite/integration/basic/src/test/java/acme_proxy/InjectMePlease.java b/testsuite/integration/basic/src/test/java/acme_proxy/InjectMePlease.java
new file mode 100644
index 0000000000..4e4fd3a95b
--- /dev/null
+++ b/testsuite/integration/basic/src/test/java/acme_proxy/InjectMePlease.java
@@ -0,0 +1,10 @@
+package acme_proxy;
+
+public class InjectMePlease {
+    private static final long serialVersionUID = 1L;
+
+    public InjectMePlease() {
+        super();
+        // TODO Auto-generated constructor stub
+    }
+}
\ No newline at end of file
diff --git a/testsuite/integration/basic/src/test/java/acme_proxy/ServletStaticClassesTest.java b/testsuite/integration/basic/src/test/java/acme_proxy/ServletStaticClassesTest.java
new file mode 100644
index 0000000000..b1e5f17a76
--- /dev/null
+++ b/testsuite/integration/basic/src/test/java/acme_proxy/ServletStaticClassesTest.java
@@ -0,0 +1,111 @@
+package acme_proxy;
+
+import static org.jboss.shrinkwrap.api.ShrinkWrap.create;
+import static org.junit.Assert.assertEquals;
+
+import java.io.BufferedReader;
+import java.io.IOException;
+import java.io.InputStreamReader;
+import java.net.HttpURLConnection;
+import java.net.URI;
+import java.util.Set;
+
+import javax.annotation.Resource;
+import javax.inject.Inject;
+import javax.enterprise.concurrent.ManagedExecutorService;
+import javax.servlet.ServletContainerInitializer;
+import javax.servlet.ServletContext;
+import javax.servlet.ServletException;
+import javax.servlet.annotation.WebServlet;
+import javax.servlet.http.HttpServlet;
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
+
+import org.jboss.arquillian.container.test.api.Deployment;
+import org.jboss.arquillian.container.test.api.RunAsClient;
+import org.jboss.arquillian.junit.Arquillian;
+import org.jboss.arquillian.test.api.ArquillianResource;
+import org.jboss.shrinkwrap.api.asset.EmptyAsset;
+import org.jboss.shrinkwrap.api.spec.JavaArchive;
+import org.jboss.shrinkwrap.api.spec.WebArchive;
+import org.junit.Test;
+import org.junit.runner.RunWith;
+
+@RunWith(Arquillian.class)
+public class ServletStaticClassesTest {
+    @ArquillianResource
+    public URI deploymentUri;
+
+    private HttpURLConnection openConnection(String path) throws IOException {
+        final URI uri = URI.create(deploymentUri.toString() + path);
+        final HttpURLConnection conn = (HttpURLConnection) uri.toURL().openConnection();
+        conn.setRequestMethod("GET");
+        return conn;
+    }
+
+    @Test
+    @RunAsClient
+    public void testDynamic() throws IOException {
+        final HttpURLConnection conn = openConnection("dynamic");
+        conn.setRequestMethod("GET");
+        try (BufferedReader reader = new BufferedReader(new InputStreamReader(conn.getInputStream()))) {
+            assertEquals("Yay!", reader.readLine());
+            assertEquals("Yay!", reader.readLine());
+            assertEquals("Yay!", reader.readLine());
+        }
+    }
+
+
+    @Deployment
+    public static WebArchive createWebArchive() {
+        return create(WebArchive.class,"acme-test.war")
+                //.addClasses(StaticServlet.class)
+                .addAsWebInfResource(EmptyAsset.INSTANCE, "beans.xml")
+                .addAsWebInfResource(ServletTest.class.getPackage(), "/web.xml","/web.xml")
+                .addAsLibrary(create(JavaArchive.class)
+                        .addAsServiceProvider(ServletContainerInitializer.class, Initialiser.class)
+                        .addClasses(DynamicServlet.class)
+                        .addClasses(InjectMePlease.class));
+
+    }
+
+    public static class Initialiser implements ServletContainerInitializer {
+        @Override
+        public void onStartup(Set<Class<?>> c, ServletContext ctx) throws ServletException {
+            ctx.addServlet("acme", DynamicServlet.class).addMapping("/dynamic");
+        }
+    }
+
+    public static class DynamicServlet extends HttpServlet {
+        private static final long serialVersionUID = 1L;
+
+        @Resource
+        private ManagedExecutorService executor;
+        @Resource(lookup = "java:comp/env/ResourceFromWebXml")
+        private Object resourceByLookupName;
+        @Inject
+        private InjectMePlease managedBean;
+        @Override
+        protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
+            resp.setContentType("text/plain");
+            //resp.getWriter().println(this.managedBean != null ? "Yay!" : "Oh no!");
+            //resp.getWriter().println(this.executor != null ? "Yay!" : "Oh no!");
+            //resp.getWriter().println(this.resourceByLookupName != null ? "Yay!" : "Oh no!");
+            resp.getWriter().println(this.executor + " "+ this.managedBean+ " " + this.resourceByLookupName);
+        }
+    }
+
+    @WebServlet("/static")
+    public static class StaticServlet extends DynamicServlet {
+        private static final long serialVersionUID = 1L;
+    }
+
+    public static class InjectMePlease {
+        private static final long serialVersionUID = 1L;
+
+        public InjectMePlease() {
+            super();
+            // TODO Auto-generated constructor stub
+        }
+    }
+}
\ No newline at end of file
diff --git a/testsuite/integration/basic/src/test/java/acme_proxy/ServletTest.java b/testsuite/integration/basic/src/test/java/acme_proxy/ServletTest.java
new file mode 100644
index 0000000000..dd1db2195a
--- /dev/null
+++ b/testsuite/integration/basic/src/test/java/acme_proxy/ServletTest.java
@@ -0,0 +1,74 @@
+package acme_proxy;
+
+import static org.jboss.shrinkwrap.api.ShrinkWrap.create;
+import static org.junit.Assert.assertEquals;
+
+import java.io.BufferedReader;
+import java.io.IOException;
+import java.io.InputStreamReader;
+import java.net.HttpURLConnection;
+import java.net.URI;
+//import java.util.Set;
+
+//import javax.annotation.Resource;
+//import javax.inject.Inject;
+//import javax.enterprise.concurrent.ManagedExecutorService;
+import javax.servlet.ServletContainerInitializer;
+//import javax.servlet.ServletContext;
+//import javax.servlet.ServletException;
+//import javax.servlet.annotation.WebServlet;
+//import javax.servlet.http.HttpServlet;
+//import javax.servlet.http.HttpServletRequest;
+//import javax.servlet.http.HttpServletResponse;
+
+import org.jboss.arquillian.container.test.api.Deployment;
+import org.jboss.arquillian.container.test.api.RunAsClient;
+import org.jboss.arquillian.junit.Arquillian;
+import org.jboss.arquillian.test.api.ArquillianResource;
+import org.jboss.shrinkwrap.api.asset.EmptyAsset;
+import org.jboss.shrinkwrap.api.spec.JavaArchive;
+import org.jboss.shrinkwrap.api.spec.WebArchive;
+import org.junit.Test;
+import org.junit.runner.RunWith;
+
+@RunWith(Arquillian.class)
+public class ServletTest {
+    @ArquillianResource
+    public URI deploymentUri;
+
+    private HttpURLConnection openConnection(String path) throws IOException {
+        final URI uri = URI.create(deploymentUri.toString() + path);
+        final HttpURLConnection conn = (HttpURLConnection) uri.toURL().openConnection();
+        conn.setRequestMethod("GET");
+        return conn;
+    }
+
+    @Test
+    @RunAsClient
+    public void testDynamic() throws IOException {
+        final HttpURLConnection conn = openConnection("dynamic");
+        conn.setRequestMethod("GET");
+        try (BufferedReader reader = new BufferedReader(new InputStreamReader(conn.getInputStream()))) {
+            assertEquals("Yay!", reader.readLine());
+            assertEquals("Yay!", reader.readLine());
+            assertEquals("Yay!", reader.readLine());
+        }
+    }
+
+    @Deployment
+    public static WebArchive createWebArchive() {
+        return create(WebArchive.class,"acme-test.war")
+                .addClasses(StaticServlet.class)
+                .addClasses(InjectMePlease.class)
+                .addAsWebInfResource(EmptyAsset.INSTANCE, "beans.xml")
+                .addAsWebInfResource(ServletTest.class.getPackage(), "/web.xml","/web.xml")
+                .addAsLibrary(create(JavaArchive.class)
+                        .addAsServiceProvider(ServletContainerInitializer.class, Initialiser.class)
+                        .addClasses(DynamicServlet.class)
+//                        .addClasses(InjectMePlease.class)
+                        .addClasses(Initialiser.class));
+
+    }
+
+
+}
\ No newline at end of file
diff --git a/testsuite/integration/basic/src/test/java/acme_proxy/StaticServlet.java b/testsuite/integration/basic/src/test/java/acme_proxy/StaticServlet.java
new file mode 100644
index 0000000000..d50ade56db
--- /dev/null
+++ b/testsuite/integration/basic/src/test/java/acme_proxy/StaticServlet.java
@@ -0,0 +1,8 @@
+package acme_proxy;
+
+import javax.servlet.annotation.WebServlet;
+
+@WebServlet("/static")
+public class StaticServlet extends DynamicServlet {
+    private static final long serialVersionUID = 1L;
+}
diff --git a/testsuite/integration/basic/src/test/java/acme_proxy/web.xml b/testsuite/integration/basic/src/test/java/acme_proxy/web.xml
new file mode 100644
index 0000000000..aad18298bf
--- /dev/null
+++ b/testsuite/integration/basic/src/test/java/acme_proxy/web.xml
@@ -0,0 +1,35 @@
+<?xml version="1.0" encoding="UTF-8"?>
+
+<!--
+  ~ JBoss, Home of Professional Open Source.
+  ~ Copyright 2011, Red Hat, Inc., and individual contributors
+  ~ as indicated by the @author tags. See the copyright.txt file in the
+  ~ distribution for a full listing of individual contributors.
+  ~
+  ~ This is free software; you can redistribute it and/or modify it
+  ~ under the terms of the GNU Lesser General Public License as
+  ~ published by the Free Software Foundation; either version 2.1 of
+  ~ the License, or (at your option) any later version.
+  ~
+  ~ This software is distributed in the hope that it will be useful,
+  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
+  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+  ~ Lesser General Public License for more details.
+  ~
+  ~ You should have received a copy of the GNU Lesser General Public
+  ~ License along with this software; if not, write to the Free
+  ~ Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+  ~ 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+  -->
+<web-app version="2.5"
+         xmlns="http://java.sun.com/xml/ns/javaee"
+         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+         xsi:schemaLocation="http://java.sun.com/xml/ns/javaee http://java.sun.com/xml/ns/javaee/web-app_2_5.xsd">
+
+    <env-entry>
+        <env-entry-name>ResourceFromWebXml</env-entry-name>
+        <env-entry-type>java.lang.String</env-entry-type>
+        <env-entry-value>someEnvEntryValue</env-entry-value>
+    </env-entry>
+
+</web-app>