Index: integrationtests/server-integration/server-integration-commons/src/test/java/org/infinispan/test/integration/embedded/CustomValue.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
diff --git a/integrationtests/server-integration/server-integration-commons/src/test/java/org/infinispan/test/integration/embedded/CustomValue.java b/integrationtests/server-integration/server-integration-commons/src/test/java/org/infinispan/test/integration/embedded/CustomValue.java
new file mode 100644
--- /dev/null	(date 1614757435388)
+++ b/integrationtests/server-integration/server-integration-commons/src/test/java/org/infinispan/test/integration/embedded/CustomValue.java	(date 1614757435388)
@@ -0,0 +1,30 @@
+package org.infinispan.test.integration.embedded;
+
+import java.io.Serializable;
+import java.util.Objects;
+
+public class CustomValue implements Serializable {
+   private final String s;
+
+   public CustomValue(String s) {
+      this.s = s;
+   }
+
+   @Override
+   public boolean equals(Object o) {
+      if (this == o) return true;
+      if (o == null || getClass() != o.getClass()) return false;
+      CustomValue that = (CustomValue) o;
+      return s.equals(that.s);
+   }
+
+   @Override
+   public int hashCode() {
+      return Objects.hash(s);
+   }
+
+   @Override
+   public String toString() {
+      return "CustomValue(" + s + '}';
+   }
+}
Index: integrationtests/server-integration/wildfly-modules/src/test/java/org/infinispan/test/integration/as/embedded/InfinispanCoreIT.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
diff --git a/integrationtests/server-integration/wildfly-modules/src/test/java/org/infinispan/test/integration/as/embedded/InfinispanCoreIT.java b/integrationtests/server-integration/wildfly-modules/src/test/java/org/infinispan/test/integration/as/embedded/InfinispanCoreIT.java
--- a/integrationtests/server-integration/wildfly-modules/src/test/java/org/infinispan/test/integration/as/embedded/InfinispanCoreIT.java	(revision 537d58b53f058de1ee9e6e975fc99b0e8d4f4c50)
+++ b/integrationtests/server-integration/wildfly-modules/src/test/java/org/infinispan/test/integration/as/embedded/InfinispanCoreIT.java	(date 1614757469567)
@@ -2,6 +2,7 @@
 
 import org.infinispan.commons.util.Version;
 import org.infinispan.test.integration.embedded.AbstractInfinispanCoreIT;
+import org.infinispan.test.integration.embedded.CustomValue;
 import org.jboss.arquillian.container.test.api.Deployment;
 import org.jboss.arquillian.junit.Arquillian;
 import org.jboss.shrinkwrap.api.Archive;
@@ -26,7 +27,7 @@
    public static Archive<?> deployment() {
       return ShrinkWrap
             .create(WebArchive.class, "simple.war")
-            .addClass(AbstractInfinispanCoreIT.class)
+            .addClasses(AbstractInfinispanCoreIT.class, CustomValue.class)
             .add(manifest(), "META-INF/MANIFEST.MF");
    }
 
Index: integrationtests/server-integration/third-party-server/src/test/java/org/infinispan/test/integration/thirdparty/embedded/InfinispanCoreIT.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
diff --git a/integrationtests/server-integration/third-party-server/src/test/java/org/infinispan/test/integration/thirdparty/embedded/InfinispanCoreIT.java b/integrationtests/server-integration/third-party-server/src/test/java/org/infinispan/test/integration/thirdparty/embedded/InfinispanCoreIT.java
--- a/integrationtests/server-integration/third-party-server/src/test/java/org/infinispan/test/integration/thirdparty/embedded/InfinispanCoreIT.java	(revision 537d58b53f058de1ee9e6e975fc99b0e8d4f4c50)
+++ b/integrationtests/server-integration/third-party-server/src/test/java/org/infinispan/test/integration/thirdparty/embedded/InfinispanCoreIT.java	(date 1614763887132)
@@ -1,7 +1,8 @@
 package org.infinispan.test.integration.thirdparty.embedded;
 
-import org.infinispan.test.integration.thirdparty.DeploymentHelper;
 import org.infinispan.test.integration.embedded.AbstractInfinispanCoreIT;
+import org.infinispan.test.integration.embedded.CustomValue;
+import org.infinispan.test.integration.thirdparty.DeploymentHelper;
 import org.jboss.arquillian.container.test.api.Deployment;
 import org.jboss.arquillian.junit.Arquillian;
 import org.jboss.shrinkwrap.api.Archive;
@@ -20,7 +21,7 @@
    @Deployment
    public static Archive<?> deployment() {
       WebArchive war = DeploymentHelper.createDeployment();
-      war.addClass(AbstractInfinispanCoreIT.class);
+      war.addClasses(AbstractInfinispanCoreIT.class, CustomValue.class);
 
       DeploymentHelper.addLibrary(war, "org.infinispan:infinispan-core");
 
Index: integrationtests/server-integration/server-integration-commons/src/test/java/org/infinispan/test/integration/embedded/AbstractInfinispanCoreIT.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
diff --git a/integrationtests/server-integration/server-integration-commons/src/test/java/org/infinispan/test/integration/embedded/AbstractInfinispanCoreIT.java b/integrationtests/server-integration/server-integration-commons/src/test/java/org/infinispan/test/integration/embedded/AbstractInfinispanCoreIT.java
--- a/integrationtests/server-integration/server-integration-commons/src/test/java/org/infinispan/test/integration/embedded/AbstractInfinispanCoreIT.java	(revision 537d58b53f058de1ee9e6e975fc99b0e8d4f4c50)
+++ b/integrationtests/server-integration/server-integration-commons/src/test/java/org/infinispan/test/integration/embedded/AbstractInfinispanCoreIT.java	(date 1614757435365)
@@ -3,6 +3,7 @@
 import static org.junit.Assert.assertEquals;
 
 import org.infinispan.Cache;
+import org.infinispan.commons.dataconversion.MediaType;
 import org.infinispan.configuration.cache.ConfigurationBuilder;
 import org.infinispan.configuration.global.GlobalConfigurationBuilder;
 import org.infinispan.manager.DefaultCacheManager;
@@ -29,11 +30,28 @@
    @Test
    public void testCacheManager() {
       GlobalConfigurationBuilder gcb = new GlobalConfigurationBuilder();
-      gcb.defaultCacheName("default");
+      cm = new DefaultCacheManager(gcb.build());
 
-      cm = new DefaultCacheManager(gcb.build(), new ConfigurationBuilder().build());
-      Cache<String, String> cache = cm.getCache();
+      ConfigurationBuilder cacheBuilder = new ConfigurationBuilder();
+      cm.defineConfiguration("c1", cacheBuilder.build());
+      Cache<String, String> cache = cm.getCache("c1");
       cache.put("a", "a");
       assertEquals("a", cache.get("a"));
    }
+
+
+   @Test
+   public void testApplicationClassDeserialization() {
+      GlobalConfigurationBuilder gcb = new GlobalConfigurationBuilder();
+      gcb.serialization().allowList().addClasses(CustomValue.class);
+      cm = new DefaultCacheManager(gcb.build());
+
+      ConfigurationBuilder cacheBuilder = new ConfigurationBuilder();
+      cacheBuilder.encoding().mediaType(MediaType.APPLICATION_SERIALIZED_OBJECT_TYPE);
+      cm.defineConfiguration("c2", cacheBuilder.build());
+
+      Cache<String, CustomValue> cache = cm.getCache("c2");
+      cache.put("a", new CustomValue("b"));
+      assertEquals(new CustomValue("b"), cache.get("a"));
+   }
 }