diff --git a/testsuite/integration/basic/src/test/java/org/jboss/as/test/integration/deployment/deploymentoverlay/war/OverlayEAP8TestCase.java b/testsuite/integration/basic/src/test/java/org/jboss/as/test/integration/deployment/deploymentoverlay/war/OverlayEAP8TestCase.java
new file mode 100644
index 0000000000..b472727545
--- /dev/null
+++ b/testsuite/integration/basic/src/test/java/org/jboss/as/test/integration/deployment/deploymentoverlay/war/OverlayEAP8TestCase.java
@@ -0,0 +1,189 @@
+package org.jboss.as.test.integration.deployment.deploymentoverlay.war;
+
+import static org.jboss.as.controller.descriptions.ModelDescriptionConstants.OUTCOME;
+import static org.jboss.as.controller.descriptions.ModelDescriptionConstants.RESULT;
+import static org.jboss.as.controller.descriptions.ModelDescriptionConstants.SUCCESS;
+
+import java.io.File;
+import java.io.IOException;
+import java.net.HttpURLConnection;
+import java.net.URL;
+import java.nio.charset.StandardCharsets;
+import java.util.concurrent.TimeoutException;
+
+import org.apache.commons.io.FileUtils;
+import org.apache.http.ConnectionClosedException;
+import org.apache.http.client.methods.CloseableHttpResponse;
+import org.apache.http.client.methods.HttpGet;
+import org.apache.http.impl.client.CloseableHttpClient;
+import org.apache.http.impl.client.HttpClientBuilder;
+import org.apache.http.util.EntityUtils;
+import org.jboss.arquillian.container.test.api.Deployer;
+import org.jboss.arquillian.container.test.api.Deployment;
+import org.jboss.arquillian.container.test.api.OperateOnDeployment;
+import org.jboss.arquillian.container.test.api.RunAsClient;
+import org.jboss.arquillian.junit.Arquillian;
+import org.jboss.arquillian.test.api.ArquillianResource;
+import org.jboss.as.arquillian.container.ManagementClient;
+import org.jboss.as.controller.PathAddress;
+import org.jboss.as.controller.PathElement;
+import org.jboss.as.controller.operations.common.Util;
+import org.jboss.as.test.integration.deployment.deploymentoverlay.AbstractOverlayTestBase;
+import org.jboss.as.test.integration.management.util.ServerReload;
+import org.jboss.dmr.ModelNode;
+import org.jboss.logging.Logger;
+import org.jboss.shrinkwrap.api.Archive;
+import org.jboss.shrinkwrap.api.ShrinkWrap;
+import org.jboss.shrinkwrap.api.asset.StringAsset;
+import org.jboss.shrinkwrap.api.spec.WebArchive;
+import org.junit.After;
+import org.junit.Assert;
+import org.junit.Before;
+import org.junit.BeforeClass;
+import org.junit.Test;
+import org.junit.runner.RunWith;
+
+@RunWith(Arquillian.class)
+@RunAsClient
+public class OverlayEAP8TestCase {
+    private static final File OVERLAY_CONTENT_DIR = new File("/home/baranowb/redhat/tmp/overlay");
+    private static final File TEST_HTML_IN_OVERLAY_DIR_FILE = new File(OVERLAY_CONTENT_DIR, "test.html");
+    private static final File OVERLAY_HTML_FILE = new File(OVERLAY_CONTENT_DIR, "overlay.html");
+    private static final String MODIFIED_TEXT_FILE_NAME = "modified.txt";
+    private static final File OVERLAY_TEXT_FILE = new File(OVERLAY_CONTENT_DIR, MODIFIED_TEXT_FILE_NAME);
+    private static final String IN_OVERLAY_TEST_HTML_CONTENT = "in overlay test html";
+    private static final String IN_APP_TEST_HTML_CONTENT = "in app test html";
+    private static final String IN_OVERLAY_OVERLAY_HTML_CONTENT = "in overlay html file content";
+
+    private static final String JBOSS_WEB_10 = "<jboss-web xmlns=\"http://www.jboss.com/xml/ns/javaee\"\n"
+            + "           xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n"
+            + "           xsi:schemaLocation=\"http://www.jboss.com/xml/ns/javaee http://www.jboss"
+            + ".org/j2ee/schema/jboss-web_7_2.xsd\"\n" + "           version=\"7.2\">\n" + "  <overlay>"
+            + OVERLAY_CONTENT_DIR.getAbsolutePath() + "</overlay>\n" + "</jboss-web>\n";
+
+    private static final String DEPLOYMENT_NAME = "overlay";
+
+    protected static final Logger LOGGER = Logger.getLogger(AbstractOverlayTestBase.class);
+
+    @ArquillianResource
+    protected ManagementClient managementClient;
+
+    @ArquillianResource
+    protected Deployer deployer;
+
+    @BeforeClass
+    public static void beforeClass() throws IOException {
+
+        OVERLAY_CONTENT_DIR.mkdirs();
+        //Arq deployment require this...
+    }
+
+    @Before
+    public void before() throws IOException {
+        FileUtils.deleteQuietly(OVERLAY_CONTENT_DIR);
+        OVERLAY_CONTENT_DIR.mkdirs();
+        FileUtils.writeStringToFile(TEST_HTML_IN_OVERLAY_DIR_FILE, IN_OVERLAY_TEST_HTML_CONTENT, StandardCharsets.UTF_8);
+        FileUtils.writeStringToFile(OVERLAY_HTML_FILE, IN_OVERLAY_OVERLAY_HTML_CONTENT, StandardCharsets.UTF_8);
+        FileUtils.writeStringToFile(OVERLAY_TEXT_FILE, IN_OVERLAY_OVERLAY_HTML_CONTENT, StandardCharsets.UTF_8);
+    }
+
+    @After
+    public void after() throws IOException {
+        FileUtils.deleteDirectory(OVERLAY_CONTENT_DIR);
+    }
+
+    @Deployment(name = DEPLOYMENT_NAME, testable = false, managed = false)
+    public static Archive<?> getDeployment() {
+        WebArchive war = ShrinkWrap.create(WebArchive.class, DEPLOYMENT_NAME + ".war");
+        war.addAsWebInfResource(new StringAsset(JBOSS_WEB_10), "jboss-web.xml");
+        war.addAsWebResource(new StringAsset("in app index"), "index.html");
+        war.addAsWebResource(new StringAsset(IN_APP_TEST_HTML_CONTENT), "test.html");
+        return war;
+    }
+
+    @Before
+    public void deploy() {
+        deployer.deploy(DEPLOYMENT_NAME);
+    }
+
+    @After
+    public void undeploy() {
+        deployer.undeploy(DEPLOYMENT_NAME);
+    }
+
+    @Test()
+    @OperateOnDeployment(DEPLOYMENT_NAME)
+    public void modifiedFileInOverlayTest2(@ArquillianResource URL url) throws IOException, TimeoutException,
+            InterruptedException {
+        for(int i =0;i<100;i++) {
+            before();
+            modifiedFileInOverlayTest(url, i);
+        }
+    }
+
+    //@Test()
+    //@OperateOnDeployment(DEPLOYMENT_NAME)
+    public void modifiedFileInOverlayTest(@ArquillianResource URL url, int t) throws IOException, TimeoutException,
+            InterruptedException {
+        final String fileCacheAttrName = "file-cache-time-to-live";
+
+        final PathAddress undertowAddress = PathAddress.pathAddress(PathElement.pathElement("subsystem", "undertow"), PathElement.pathElement("servlet-container", "default"));
+        ModelNode readAttribute = Util.getReadAttributeOperation(undertowAddress, fileCacheAttrName);
+        ModelNode answer = managementClient.getControllerClient().execute(readAttribute);
+        Assert.assertTrue(answer.asString(), SUCCESS.equals(answer.get(OUTCOME).asString()));
+        String origFileCatch = answer.get(RESULT).asString();
+        try (CloseableHttpClient httpClient = HttpClientBuilder.create().build()) {
+            String uri = url.toExternalForm() + MODIFIED_TEXT_FILE_NAME;
+            ModelNode writeAttribute = Util.getWriteAttributeOperation(undertowAddress, fileCacheAttrName, 0);
+            answer = managementClient.getControllerClient().execute(writeAttribute);
+            Assert.assertTrue(answer.asString(), SUCCESS.equals(answer.get(OUTCOME).asString()));
+            ServerReload.executeReloadAndWaitForCompletion(managementClient.getControllerClient());
+
+            // First check initial value of the file
+            retrieveAndCheck(httpClient, uri, IN_OVERLAY_OVERLAY_HTML_CONTENT, null, "["+t+"]");
+
+            final String modifiedText = "modified value";
+            FileUtils.writeStringToFile(OVERLAY_TEXT_FILE, modifiedText, StandardCharsets.UTF_8);
+
+
+            final String failingMessage = "failed probably due to https://issues.jboss.org/browse/JBEAP-11674";
+            // Now check modified value of the file
+            retrieveAndCheck(httpClient, uri, modifiedText, failingMessage, "["+t+"]");
+
+            final String modifiedText2 = "modified value some new";
+            FileUtils.writeStringToFile(OVERLAY_TEXT_FILE, modifiedText2, StandardCharsets.UTF_8);
+
+            // Again check modified value of the file
+            retrieveAndCheck(httpClient, uri, modifiedText2, failingMessage, "["+t+"]");
+        } finally {
+            if (origFileCatch != null && !origFileCatch.equals("undefined")) {
+                ModelNode writeAttribute = Util.getWriteAttributeOperation(undertowAddress, fileCacheAttrName, Integer.parseInt(origFileCatch));
+                answer = managementClient.getControllerClient().execute(writeAttribute);
+                Assert.assertTrue(answer.asString(), SUCCESS.equals(answer.get(OUTCOME).asString()));
+                ServerReload.executeReloadAndWaitForCompletion(managementClient.getControllerClient());
+            }
+        }
+    }
+
+    private void retrieveAndCheck(CloseableHttpClient httpClient, String uri, String expectedText, String
+            failingMessage, String intel) throws IOException {
+        try (CloseableHttpResponse testHtmlResponse = httpClient.execute(new HttpGet(uri))) {
+            Assert.assertEquals("Accessing " + uri + " failed",
+                    HttpURLConnection.HTTP_OK, testHtmlResponse.getStatusLine().getStatusCode());
+            String message = "The overlay content does not match what we expected";
+            if (failingMessage != null && !failingMessage.isEmpty()) {
+                message += failingMessage;
+            } else {
+                message += ".";
+            }
+            Assert.assertEquals(message,
+                    expectedText, EntityUtils.toString(testHtmlResponse.getEntity()));
+        } catch (ConnectionClosedException e) {
+            final String msg = "["+intel+"] ConnectionClosedException occurred during reading http response entity!";
+            e.printStackTrace();
+            LOGGER.error(msg, e);
+            Assert.fail(msg + " Probably due to https://issues.jboss.org/browse/JBEAP-12513");
+        }
+    }
+
+}
diff --git a/testsuite/integration/basic/src/test/resources/arquillian.xml b/testsuite/integration/basic/src/test/resources/arquillian.xml
index 3181fba174..ceffd1da1a 100644
--- a/testsuite/integration/basic/src/test/resources/arquillian.xml
+++ b/testsuite/integration/basic/src/test/resources/arquillian.xml
@@ -7,7 +7,7 @@
     <container qualifier="jboss" default="true">
         <configuration>
             <property name="jbossHome">${jboss.install.dir}</property>
-            <property name="javaVmArguments">${server.jvm.args}</property>
+            <property name="javaVmArguments">${server.jvm.args} -agentlib:jdwp=transport=dt_socket,address=8787,server=y,suspend=n</property>
             <property name="serverConfig">${jboss.server.config.file.name:standalone.xml}</property>
             <property name="jbossArguments">${jboss.args}</property>
             <!-- -Djboss.inst is not necessarily needed, only in case the test case neeeds path to the instance it runs in.